/****************************************************************************
**
** SPDX-License-Identifier: BSD-2-Clause-Patent
**
** SPDX-FileCopyrightText: Copyright (c) 2024 SoftAtHome
**
** Redistribution and use in source and binary forms, with or
** without modification, are permitted provided that the following
** conditions are met:
**
** 1. Redistributions of source code must retain the above copyright
** notice, this list of conditions and the following disclaimer.
**
** 2. Redistributions in binary form must reproduce the above
** copyright notice, this list of conditions and the following
** disclaimer in the documentation and/or other materials provided
** with the distribution.
**
** Subject to the terms and conditions of this license, each
** copyright holder and contributor hereby grants to those receiving
** rights under this license a perpetual, worldwide, non-exclusive,
** no-charge, royalty-free, irrevocable (except for failure to
** satisfy the conditions of this license) patent license to make,
** have made, use, offer to sell, sell, import, and otherwise
** transfer this software, where such license applies only to those
** patent claims, already acquired or hereafter acquired, licensable
** by such copyright holder or contributor that are necessarily
** infringed by:
**
** (a) their Contribution(s) (the licensed copyrights of copyright
** holders and non-copyrightable additions of contributors, in
** source or binary form) alone; or
**
** (b) combination of their Contribution(s) with the work of
** authorship to which such Contribution(s) was added by such
** copyright holder or contributor, if, at the time the Contribution
** is added, such addition causes such combination to be necessarily
** infringed. The patent license shall not apply to any other
** combinations which include the Contribution.
**
** Except as expressly stated above, no rights or licenses from any
** copyright holder or contributor is granted under this license,
** whether expressly, by implication, estoppel or otherwise.
**
** DISCLAIMER
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
** CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
** INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
** MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
** CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
** USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
** AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
** LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
** ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
**
****************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <limits.h>

#include <amxc/amxc.h>
#include <amxc/amxc_macros.h>
#include <debug/sahtrace.h>
#include <debug/sahtrace_macros.h>

#include "deviceinfo_system_hostname.h"

deviceinfo_system_hostname_t deviceinfo_system_hostname = {
    .hosts_file = "/etc/hosts",
    .hosts_tmp_file = "/etc/hosts.new",
};

static int update_hostname(const char* hostname) {
    int rv = -1;
    char hostname_old[HOST_NAME_MAX + 1] = {0};

    when_str_empty_trace(hostname, exit, ERROR, "Hostname is empty!");

    rv = gethostname(hostname_old, sizeof(hostname_old) - 1);
    if(rv != 0) {
        SAH_TRACEZ_WARNING(ME, "gethostname failed: %s", strerror(errno));
    }

    if(strcmp(hostname, hostname_old) == 0) {
        SAH_TRACEZ_INFO(ME, "Hostname unchanged: %s", hostname);
        rv = 0;
        goto exit;
    }

    // expect the data model parameter to have a validator according to manpage hostname(5)
    rv = sethostname(hostname, strlen(hostname));
    when_failed_trace(rv, exit, ERROR, "sethostname(%s) failed: %s", hostname, strerror(errno));

    SAH_TRACEZ_WARNING(ME, "Updated the system hostname from '%s' to '%s'", hostname_old, hostname);
    rv = 0;
exit:
    return rv;
}

static int generate_new_etc_hosts(const char* old, const char* new, const char* hostname) {
    int rv = -1;
    static const char* gen_token = "generated by deviceinfo-system";
    char* line = NULL;
    size_t len = 0;
    bool ignore_first_empty_line = false;

    FILE* hosts_old = fopen(old, "r");
    FILE* hosts_new = NULL;

    when_null_trace(hosts_old, exit, ERROR, "Failed to open %s: %s", old, strerror(errno));

    hosts_new = fopen(new, "w");
    when_null_trace(hosts_new, exit, ERROR, "Failed to open %s: %s", new, strerror(errno));

    when_false_trace(fprintf(hosts_new,
                             "127.0.0.1 %s # %s\n"
                             "::1 %s # %s\n"
                             "\n",
                             hostname, gen_token,
                             hostname, gen_token) > 0, exit,
                     ERROR, "Failed to write hostname to new hosts file");

    while(getline(&line, &len, hosts_old) != -1) {
        if(strstr(line, gen_token) != NULL) {
            ignore_first_empty_line = true;
            continue;
        }
        if(ignore_first_empty_line && (strcmp(line, "\n") == 0)) {
            ignore_first_empty_line = false;
            continue;
        }

        when_false_trace(fputs(line, hosts_new) >= 0, exit,
                         ERROR, "Failed to copy line to new hosts file: %s", line);
    }

    rv = 0;
exit:
    if(hosts_old != NULL) {
        fclose(hosts_old);
    }
    if(hosts_new != NULL) {
        fclose(hosts_new);
    }
    if(line != NULL) {
        free(line);
    }
    return rv;
}

static void update_hostname_in_etc_hosts(UNUSED const char* hostname) {
    when_failed_trace(generate_new_etc_hosts(deviceinfo_system_hostname.hosts_file,
                                             deviceinfo_system_hostname.hosts_tmp_file,
                                             hostname),
                      exit, ERROR, "Failed to generate tmp hosts file: %s",
                      deviceinfo_system_hostname.hosts_tmp_file);
    when_failed_trace(rename(deviceinfo_system_hostname.hosts_tmp_file,
                             deviceinfo_system_hostname.hosts_file),
                      exit, ERROR, "Failed to move %s over %s",
                      deviceinfo_system_hostname.hosts_tmp_file,
                      deviceinfo_system_hostname.hosts_file);
exit:
    return;
}

static void deviceinfo_system_update_hostname(const char* hostname) {
    when_failed(update_hostname(hostname), exit);
    update_hostname_in_etc_hosts(hostname);
exit:
    return;
}

void _deviceinfo_system_hostname_changed(UNUSED const char* const sig_name,
                                         const amxc_var_t* const event_data,
                                         UNUSED void* const priv) {
    SAH_TRACEZ_IN(ME);
    const char* hostname = GETP_CHAR(event_data, "parameters." DM_SYS_HOSTNAME ".to");

    deviceinfo_system_update_hostname(hostname);
    SAH_TRACEZ_OUT(ME);
}

void _deviceinfo_system_hostname_init(UNUSED const char* const sig_name,
                                      UNUSED const amxc_var_t* const event_data,
                                      UNUSED void* const priv) {
    SAH_TRACEZ_IN(ME);
    amxd_object_t* sys = amxd_dm_findf(deviceinfo_system_get_dm(), DM_SYSTEM);
    const char* hostname = GET_CHAR(amxd_object_get_param_value(sys, DM_SYS_HOSTNAME), NULL);

    deviceinfo_system_update_hostname(hostname);
    SAH_TRACEZ_OUT(ME);
}
